/* A useful tool */
/* Copyright (c)1999 ADM (andrew@mcdonald.org.uk) */

#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include "stegfs.h"

int main(int argc, char *args[]) {
  struct stegfs_fs fs;
  struct stegfs_fs *fssys = &fs;
  struct inoblocks *inob;
  int j;

  if (!open_fs(fssys, args[1], args[2], "rc6")) {
    printf("Failed to open device or file\n");
    return 2;
  }

  if(!get_ext2_super(fssys)) {
    return 3;
  }

  get_stegfs_inodes(fssys);

  inob = fssys->inob[0];
  while(inob) {
    printf("%u:", inob->inode);
    for(j=0; j<STEGFS_MAX_INO_COPIES; j++)
      printf(" %u", inob->block[j]);
    printf("\n");
    inob = inob->next;
  }

  return 0;
}
