/* $Id: stegfs.h,v 1.6 1999/08/06 16:16:05 adm36 Exp $ */
#include <stdio.h>
#include <linux/fs.h>
#include <linux/stegfs_fs.h>

/*
struct stegfs_cipher {
	char *id;
	char * (*set_key) (const char *, const unsigned int);
	void (*encrypt) (const char *, const char *, char *);
	void (*decrypt) (const char *l_key, const char *, char *out_blk);
};
*/

struct stegfs_fs {

  FILE *fsfile;
  FILE *btabfile;

  struct ext2_super_block sb;

  struct inoblocks *inob[STEGFS_MAX_LEVELS-1];

  u_int32_t *bbarray;
  u_int32_t groups;

  int slevel;

  struct stegfs_cipher *cipher;
};

int open_fs(struct stegfs_fs *fs, char *fsname, char *btabname, char *cipher);
int close_fs(struct stegfs_fs *fs);
int get_ext2_super(struct stegfs_fs *fs);
int get_stegfs_inodes(struct stegfs_fs *fs);
int get_bbpos(struct stegfs_fs *fs);
void randomize_empties(struct stegfs_fs *fs);
u_int8_t isblockused(struct stegfs_fs *fs, u_int32_t blocknum);
u_int8_t stegfs_isblockused(struct stegfs_fs *fs, u_int32_t blocknum);
u_int32_t get_new_block(struct stegfs_fs *fs);
int get_new_inode(struct stegfs_fs *fs, int ino, int numcopies,
		  u_int32_t *blocks, char *skey);
void put_btab(struct stegfs_fs *fs, u_int32_t bnum,
	      struct stegfs_btable *btab);
void get_btab(struct stegfs_fs *fs, u_int32_t bnum,
	      struct stegfs_btable *btab);
unsigned int stegfs_chksum(unsigned char * data, int size);
char *make_key(char *passwd, unsigned int blocknum);

void encrypt_cbc(struct stegfs_fs *, char *key, char *data, int size);
void encrypt_cbc2(struct stegfs_fs *, char *key, char *data, char *data2, int size);
void decrypt_cbc(struct stegfs_fs *, char *key, char *data, int size);
void decrypt_cbc2(struct stegfs_fs *, char *key, char *data, char *data2, int size);

void encrypt_skey(struct stegfs_fs *, char *passwd, char *skey, char *skeyout);
void decrypt_skey(struct stegfs_fs *, char *passwd, char *skey, char *skeyout);


